local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')

function OnPopulate()
	ScenarioUtils.InitializeArmies()
        SetAlliance('ARMY_9', 'ARMY_3', 'Enemy')
	SetAlliance('ARMY_9', 'ARMY_1', 'Ally')
	SetAlliance('ARMY_9', 'ARMY_2', 'Ally')
        --ScenarioFramework.SetPlayableArea(ScenarioUtils.AreaToRect('AREA_1'))
end

--ptite fonction qui met les degats d'une arme a la valeur voulue
setWeaponDamage = function(weapon,value)
	local bp = weapon:GetBlueprint()
	weapon.DamageMod = 0
	weapon:AddDamageMod(-bp.Damage)
	weapon:AddDamageMod(value)
end

--ptite fonction qui met les degats de toutes les armes dune unit� a la valeur voulue
setDamage = function(unit,value)
	for i = 1, unit:GetWeaponCount() do
		setWeaponDamage(unit:GetWeapon(i),1)
	end
end

--Une ptite fonction qui fait tout ca tout seul
--CreerUnitPerso(nom_unit, x, y, armee1, armee2, kills, pv) : Cree l'unit 'nom_unit' a la position (x,y)  avec 'pv' points de vie pour l'arm�e 1 quand l'arm�e 2 a fait 'kills' kills
function CreerUnitPerso(nom_unit, x, y, armee1, armee2, kills, pv)
	ForkThread( function()		
		local unit = false
		while unit == false do
			if GetArmyBrain(armee2):GetArmyStat('Enemies_Killed',0.0).Value >= kills then
				unit = CreateUnitHPR(nom_unit, armee1,x,60.00,y,0,0,0) 
				unit:SetMaxHealth(pv)
				unit:SetHealth(nil,pv)
				print("les renfort sont arriver commander")
			end
			WaitSeconds(1)
		end
	end)
end

function OnStart(self)

    --CreerUnitPerso(nom_unit, x, y, armee1, armee2, kills, pv) : Cree l'unit 'nom_unit' a la position (x,y)  avec 'pv' points de vie pour l'arm�e 1 quand l'arm�e 2 a fait 'kills' kills
	CreerUnitPerso('URL0402',1227.43,93.92,'ARMY_4','ARMY_4',750,200000)
	CreerUnitPerso('URL0402',113.70,1439.68,'ARMY_3','ARMY_3',750,200000)
	CreerUnitPerso('UEL0401',1227.43,93.92,'ARMY_1','ARMY_1',1000,250000)
	CreerUnitPerso('UEL0401',113.70,1439.68,'ARMY_2','ARMY_2',1000,250000)
        CreerUnitPerso('URS0302',1050.30,468.98,'ARMY_3','ARMY_3',200,100000,3000)
        CreerUnitPerso('UES0302',1050.30,468.98,'ARMY_1','ARMY_1',200,100000,3000)
        CreerUnitPerso('UES0302',1050.30,468.98,'ARMY_2','ARMY_2',200,100000,3000)
        CreerUnitPerso('URS0302',1050.30,468.98,'ARMY_4','ARMY_4',200,100000,3000)

	CreateUnitHPR('ueb2401', 'ARMY_9',185.39,60.00,108.36,0,0,0)
	CreateUnitHPR('ueb2301', 'ARMY_9',49.35,79.99,263.58,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_9',63.00,79.99,266.70,0,0,0)
	CreateUnitHPR('ueb2304', 'ARMY_9',73.85,80.47,266.83,0,0,0)
	CreateUnitHPR('ueb0301', 'ARMY_2',188.65,60.00,190.13,0,0,0)
	CreateUnitHPR('ueb0301', 'ARMY_1',91.81,60.00,75.80,0,0,0)
	CreateUnitHPR('ueb1301', 'ARMY_1',97.69,60.00,69.19,0,0,0)
	CreateUnitHPR('ueb1301', 'ARMY_2',170.43,60.00,204.35,0,0,0)
	CreateUnitHPR('ueb3104', 'ARMY_1',223.13,60.00,162.72,0,0,0)
	CreateUnitHPR('ueb3104', 'ARMY_2',225,60.00,162.72,0,0,0)
	CreateUnitHPR('ues0302', 'ARMY_2',1057.32,34.99,468.98,0,0,0)
	CreateUnitHPR('ues0302', 'ARMY_1',479.37,34.99,975.45,0,0,0)
	CreateUnitHPR('ues0304', 'ARMY_2',1057.32,34.99,468.98,0,0,0)
	CreateUnitHPR('ues0304', 'ARMY_1',479.37,34.99,975.45,0,0,0)
	CreateUnitHPR('url0402', 'ARMY_3',1840.22,84.99,1219.40,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_1',268.34,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_2',321.53,60.00,181.45,0,0,0)
	CreateUnitHPR('urb1301', 'ARMY_3',2010.38,84.99,1193.55,0,0,0)
	CreateUnitHPR('ura0302', 'ARMY_3',2006.72,84.99,1194.11,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_1',269,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_1',266,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_2',264,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb2301', 'ARMY_2',260,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb2301', 'ARMY_1',258,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb2301', 'ARMY_2',255,60.00,232.36,0,0,0)
	CreateUnitHPR('ueb4301', 'ARMY_1',293.16,60.00,197.64,0,0,0)
	CreateUnitHPR('ueb4301', 'ARMY_2',268.23,60.00,215.72,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_1',323.47,60.00,191.01,0,0,0)
	CreateUnitHPR('ueb2303', 'ARMY_2',320,60.00,190,0,0,0)
	CreateUnitHPR('ueb2301', 'ARMY_1',318,60.00,188,0,0,0)
	CreateUnitHPR('ueb2205', 'ARMY_2',520.51,34.99,793.50,0,0,0)
	CreateUnitHPR('ueb2205', 'ARMY_1',518,34.99,793.50,0,0,0)
	CreateUnitHPR('ueb2205', 'ARMY_1',1082.15,34.99,436.87,0,0,0)
	CreateUnitHPR('ueb2205', 'ARMY_2',1080,34.99,436.87,0,0,0)
	CreateUnitHPR('urb1301', 'ARMY_3',2028,84.99,1664.15,0,0,0)
	CreateUnitHPR('url0402', 'ARMY_3',1836.86,84.99,1195.64,0,0,0)
	CreateUnitHPR('uel0401', 'ARMY_1',101.08,60.00,366.78,0,0,0)
	CreateUnitHPR('uel0401', 'ARMY_2',162.92,60.00,379.45,0,0,0)
	CreateUnitHPR('url0402', 'ARMY_3',84.70,60.00,1225.07,0,0,0)
	CreateUnitHPR('url0402', 'ARMY_3',80,60.00,1225.07,0,0,0)
	CreateUnitHPR('uel0401', 'ARMY_2',315.26,60.00,237.92,0,0,0)
	CreateUnitHPR('urb0301', 'ARMY_3',1988.07,84.99,1080.04,0,0,0)
	
	for i=1,30 do
	     CreateUnitHPR('uel0303', 'ARMY_1',191.00+i*5,60.00,464.75,0,0,0)
	end
	
	for i=1,30 do
	     CreateUnitHPR('uel0303', 'ARMY_2',498.91+i*5,60.00,120.28,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('ueb1301', 'ARMY_2',116.66+i*5,60.00,211.12,0,0,0)
	end
	   
	for i=1,10 do
	     CreateUnitHPR('ueb2303', 'ARMY_2',393.01,79.99,56.70+i*5,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('ueb1301', 'ARMY_1',135.68+i*5,60.00,62.01,0,0,0)
	end
	   
	for i=1,10 do
	     CreateUnitHPR('ueb2303', 'ARMY_1',98.22+i*5,79.98,267.17,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('ueb1303', 'ARMY_1',139.60+i*5,60.00,62.77+i*5,0,0,0)
	end
	 
	for i=1,15 do
	     CreateUnitHPR('ueb2301', 'ARMY_9',302.17+i*5,60.00,214.03,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('ueb1303', 'ARMY_2',125.62+i*5,60.00,227.78,0,0,0)
	end
	  
	for i=1,70 do
	     CreateUnitHPR('uel0202', 'ARMY_2',110.40+i*5,60.00,787.59,0,0,0)
	end
	   
	for i=1,10 do
	     CreateUnitHPR('ueb2304', 'ARMY_9',260.91+i*5,60.00,192.11,0,0,0)
	end
	   
	for i=1,10 do
	     CreateUnitHPR('urb2303', 'ARMY_3',1923.97,84.99,1180.52+i*5,0,0,0)
	end
	   
	for i=1,10 do
	     CreateUnitHPR('urb2304', 'ARMY_4',2038.02,84.99,1242.8+i*5,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('urb1301', 'ARMY_4',2008.10+i*5,84.99,1348.42,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('urb1303', 'ARMY_4',2007.51+i*5,84.99,1369.50,0,0,0)
	end
	   
	for i=1,6 do
	     CreateUnitHPR('urs0201', 'ARMY_4',1883.78+i*5,84.99,1078.83+i*5,0,0,0)
	end
	
	for i=1,10 do
	     CreateUnitHPR('uea0304', 'ARMY_1',196.67+i*5,60.00,102.41,0,0,0)
	end
	   
	for i=1,3 do
	     CreateUnitHPR('urb0301', 'ARMY_4',1995.55+i*5,84.99,1274.45,0,0,0)
	end
	   
	for i=1,2 do
	     CreateUnitHPR('urb1301', 'ARMY_3',2026.54+i*5,84.99,1078.81,0,0,0)
	end
	
	for i=1,2 do
	     CreateUnitHPR('urb1303', 'ARMY_3',2027.35+i*5,84.99,1072.97,0,0,0)
	end
	
	for i=1,2 do
	     CreateUnitHPR('url0301', 'ARMY_3',1996.59+i*5,84.99,1195.85,0,0,0)
	end

end

